/* label_init.h file */

#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <net/if.h>
#include <net/route.h>
#include <net/if_types.h>
#include <netinet/in.h>
#include <netinet/label_table.h>
#include "rsvp_socks.h"
#include "rsvp.h"
#include "rsvp_stats.h"
#include "rsvp_var.h"
#include "rsvp_global.h"
#if defined(CAIRN) || defined(TUNNEL)
#include <net/if_dl.h>

#define ROUNDUP(a) \
	((a) > 0 ? (1 + (((a) - 1) | (sizeof(long) - 1))) : sizeof(long))
#define ADVANCE(x,n) (x += ROUNDUP((n)->sa_len))
static struct sockaddr sa_zero = { sizeof(sa_zero), AF_INET, };
struct atm_pseudohdr {
  u_int8_t atm_ph[4];	/* flags+VPI+VCI1(msb)+VCI2(lsb) */
};

#endif

#define MAX_LABEL_LIMIT 100
#define MAX_INTERFACE_LIMIT 4

typedef struct table {
   u_int32_t Label;
   short    use_flag;
   } table_t;

table_t LabelInitTable[MAX_INTERFACE_LIMIT][MAX_LABEL_LIMIT];
char Interface[MAX_INTERFACE_LIMIT][5];

int find_interface(char *);
Label * new_label_obj(u_char);
u_int32_t Get_Label(int);
int Init_Table();
int Free_Label(char *, u_int32_t);
int IsLabelEnabled(char *);
int pass_msg_2_rtsock(LabelTableEntryPtr, char *, int);
int Add_label_to_route(Session *, RSB *);

